/***************************************************************************
 *   Copyright (C) 2006 - 2007 by Ian Ventura-Whiting (Fizz)               *
 *   Fizz@Titania.co.uk                                                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


// Banner
struct bannerConfig
{
	char *line;
	struct bannerConfig *next;
};


// Process Banner
void processBanner(char *line, struct ciscoIOSConfig *config, FILE *input, int lineSize, const int debugMode)
{
	// Variables
	struct bannerConfig *bannerPointer;
	struct ciscoCommand command;
	char bannerTerminator[3];

	// Debug
	if (debugMode == true)
	{
		printf("Banner Line: %s\n", line);
	}

	// Only process if banner has not already been set and banner line is made up of 3 parts...
	command = splitLine(line);
	if ((config->banner == 0) && (command.parts == 3))
	{
		// init
		memset(bannerTerminator, 0, sizeof(bannerTerminator));
		strncpy(bannerTerminator, command.part[2], 2);

		// Read next line
		readLine(input, line, lineSize);

		// Get all parts of the banner message...
		while ((strstr(line, bannerTerminator) == 0) && (feof(input) == 0))
		{
			if (debugMode == true)
			{
				printf("Banner: %s\n", line);
			}

			// Is this the first line of text...
			if (config->banner == 0)
			{
				// create struct
				config->banner = malloc(sizeof(struct bannerConfig));
				bannerPointer = config->banner;
			}

			// or Add another line...
			else
			{
				// Create structure
				bannerPointer->next = malloc(sizeof(struct bannerConfig));
				bannerPointer = bannerPointer->next;
			}

			// Init structure...
			memset(bannerPointer, 0, sizeof(struct bannerConfig));
			bannerPointer->line = malloc(strlen(line) + 1);
			strcpy(bannerPointer->line, line);
			bannerPointer->next = 0;

			// Read next line
			readLine(input, line, lineSize);
		}
	}
}


