/***************************************************************************
 *   Copyright (C) 2006 - 2007 by Ian Ventura-Whiting (Fizz)               *
 *   Fizz@Titania.co.uk                                                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


// Logging config
struct loggingConfig
{
	int localLogging;				// true or false
	int consoleLogging;				// true or false
	struct host *logServer;
};


// Process Logging
void processLogging(char *line, struct ciscoIOSConfig *config, const int debugMode)
{
	// Variables...
	struct host *logServerPointer;

	// Debug
	if (debugMode == true)
	{
		printf("Logging Line: %s\n", line);
	}

	// Create logging structure
	if (config->logging == 0)
	{
		config->logging = malloc(sizeof(struct loggingConfig));
		memset(config->logging, 0, sizeof(struct loggingConfig));

		// init
		config->logging->localLogging = unconfigured;
		config->logging->consoleLogging = true;
		config->logging->logServer = 0;
	}

	// Logging on
	if (strncmp(line, "logging on", 10) == 0)
		config->logging->localLogging = true;

	// Console logging disabled
	else if (strncmp(line, "no logging console", 18) == 0)
		config->logging->consoleLogging = false;

	// Console logging enabled (for something, not checked)
	else if (strncmp(line, "logging console", 15) == 0)
		config->logging->consoleLogging = true;

	// Logging server
	else if ((strncmp(line, "logging ", 8) == 0) && (line[8] > 47) && (line[8] < 58))
	{
		// create structure
		logServerPointer = malloc(sizeof(struct host));
		memset(logServerPointer, 0, sizeof(struct host));

		// update pointers
		logServerPointer->next = config->logging->logServer;
		config->logging->logServer = logServerPointer;

		// add server
		strncpy(logServerPointer->server, line + 8, sizeof(logServerPointer->server));
	}
}


