/***************************************************************************
 *   Copyright (C) 2006 - 2007 by Ian Ventura-Whiting (Fizz)               *
 *   Fizz@Titania.co.uk                                                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


void reportIOSDebug(struct ciscoIOSConfig *config)
{
	// Variables
	struct accessList *accessPointer;
	struct accessListPermission *permissionPointer;
	struct enablePassword *enablePointer;
	struct ntpKey *ntpKeyPointer;
	struct ntpHost *ntpHostPointer;
	struct ntpAccessGroup *ntpAccessPointer;
	struct snmpCommunity *communityPointer;
	struct snmpViewItem *snmpViewItemPointer;
	struct snmpView *snmpViewPointer;
	struct snmpGroup *snmpGroupPointer;
	struct snmpUser *snmpUserPointer;
	struct snmpTrap *snmpTrapPointer;
	struct snmpHost *snmpHostPointer;
	struct johnPassword *johnPointer;
	struct usernameList *usernamePointer;
	struct privilageLevels *privilagePointer;
	struct host *logServerPointer;
	struct host *tacacsHostPointer;
	struct aaaGroupServer *aaaGroupServerPointer;
	struct aaaServer *aaaServerPointer;
	struct netInterface *interfacePointer;
	struct interfaceConfig *interfaceConfigPointer;
	struct bgpNeighbor *neighborPointer;
	struct keyChain *keyChainPointer;
	struct keyConfig *keyPointer;
	struct lineConfig *linePointer;
	struct bannerConfig *bannerPointer;
	struct ospfNetworkConfig *ospfNetworkPointer;
	struct ospfAreaConfig *ospfAreaPointer;
	struct ospfNeighbor *ospfNeighborPointer;
	struct staticRoute *routePointer;

	// Setting info
	printf("\n\nFor some debug settings...\n");
	printf("True or Enabled = %d\n", true);
	printf("False or Disabled = %d\n", false);
	printf("Unconfigured = %d\n\n", unconfigured);

	// General Info
	printf("\n%sInformation Collected\n=====================%s\n", COL_BLUE, RESET);
	printf("Hostname: %s\n", config->hostname);
	printf("IOS Version: %s\n", config->version);
	printf("IOS Version: %d.%d\n", config->versionMajor, config->versionMinor);
	printf("IP Source Routing: %d\n", config->sourceRouting);
	printf("Service Password Encryption: %d\n", config->servicePasswordEncryption);
	printf("TCP Small Servers: %d\n", config->tcpSmallServers);
	printf("UDP Small Servers: %d\n", config->udpSmallServers);
	printf("Finger: %d\n", config->finger);
	printf("CDP: %d\n", config->cdp);
	printf("PAD: %d\n", config->pad);
	printf("Bootp: %d\n", config->bootp);
	printf("Network Boot: %d\n", config->bootNetwork);
	printf("Service Config: %d\n", config->serviceConfig);
	printf("Domain Lookup: %d\n", config->domainLookup);
	printf("Number of weak passwords / keys: %d\n", config->passwordStrengths);
	printf("Number of dictionary-based passwords / keys: %d\n", config->simplePasswords);

	// SSH
	if (config->ssh != 0)
	{
		printf("SSH Enabled: %d\n", config->ssh->enabled);
		printf("  SSH Protocol Version: %d\n", config->ssh->protocolVersion);
		printf("  SSH Login Timeout: %d\n", config->ssh->timeout);
		printf("  SSH Login Retries: %d\n", config->ssh->retries);
		interfacePointer = config->ssh->interface;
		while (interfacePointer != 0)
		{
			printf("  SSH Server Interface: %s\n", interfacePointer->interface);
			interfacePointer = interfacePointer->next;
		}
	}

	// HTTP
	if (config->http != 0)
	{
		printf("HTTP Enabled: %d\n", config->http->enabled);
		printf("  HTTP Authentication: %d\n", config->http->authentication);
		printf("  HTTP Access-Class: %d\n", config->http->accessClass);
	}

	// Enable
	enablePointer = config->enable;
	while (enablePointer != 0)
	{
		printf("Enable Level: %d\n", enablePointer->level);
		printf("  Encryption Type: %d\n", enablePointer->encryption);
		printf("  Secret?: %d\n", enablePointer->secret);
		printf("  Password: %s\n", enablePointer->password);
		printf("  Password Encrypted: %s\n", enablePointer->passwordEncrypted);
		printf("  Weak Password: %d\n", enablePointer->weak);
		printf("  Dictionary Password: %d\n", enablePointer->dictionary);
		enablePointer = enablePointer->next;
	}

	// Username
	usernamePointer = config->username;
	while (usernamePointer != 0)
	{
		printf("Username: %s\n", usernamePointer->username);
		printf("  Encryption Type: %d\n", usernamePointer->encryption);
		printf("  Secret?: %d\n", usernamePointer->secret);
		printf("  Privilage Level: %d\n", usernamePointer->privilage);
		printf("  Password: %s\n", usernamePointer->password);
		printf("  Password Encrypted: %s\n", usernamePointer->passwordEncrypted);
		printf("  Weak Password: %d\n", usernamePointer->weak);
		printf("  Dictionary Password: %d\n", usernamePointer->dictionary);
		usernamePointer = usernamePointer->next;
	}

	// Privilage
	privilagePointer = config->privilage;
	while (privilagePointer != 0)
	{
		printf("Privilage Level: %d\n", privilagePointer->level);
		printf("  Privilage Command: %s\n", privilagePointer->command);
		privilagePointer = privilagePointer->next;
	}

	// Banner
	bannerPointer = config->banner;
	while (bannerPointer != 0)
	{
		printf("Banner: %s\n", bannerPointer->line);
		bannerPointer = bannerPointer->next;
	}

	// Logging
	if (config->logging != 0)
	{
		printf("Local Logging: %d\n", config->logging->localLogging);
		printf("Console Logging: %d\n", config->logging->consoleLogging);
		logServerPointer = config->logging->logServer;
		while (logServerPointer != 0)
		{
			printf("Logging Server: %s\n", logServerPointer->server);
			logServerPointer = logServerPointer->next;
		}
	}

	// Routing
	if (config->route != 0)
	{
		routePointer = config->route;
		while (routePointer != 0)
		{
			printf("Static Route\n");
			printf("  IP Address: %s\n", routePointer->ipAddress);
			printf("  Net Mask: %s\n", routePointer->netMask);
			printf("  Gateway: %s\n", routePointer->gateway);
			routePointer = routePointer->next;
		}
	}
	if (config->bgp != 0)
	{
		printf("BGP Autonomous No: %d\n", config->bgp->autonomousNo);
		printf("BGP Log Changes: %d\n", config->bgp->logNeighborChanges);
		printf("BGP Dampening: %d\n", config->bgp->dampening);
		neighborPointer = config->bgp->neighbor;
		while (neighborPointer != 0)
		{
			printf("BGP Neighbor: %s\n", neighborPointer->host);
			printf("  BGP Neighbor Description: %s\n", neighborPointer->description);
			printf("  BGP Password Encryption Type: %d\n", neighborPointer->encryption);
			printf("  BGP Password: %s\n", neighborPointer->password);
			printf("  BGP Password Encrypted: %s\n", neighborPointer->passwordEncrypted);
			printf("  BGP Neighbor Password: %s\n", neighborPointer->password);
			printf("  BGP Weak Password: %d\n", neighborPointer->weak);
			printf("  BGP Dictionary Password: %d\n", neighborPointer->dictionary);
			printf("  BGP Neighbor Autonomous No: %d\n", neighborPointer->autonomousNo);
			printf("  BGP Neighbor TTL Hops: %d\n", neighborPointer->ttlHops);
			neighborPointer = neighborPointer->next;
		}
	}
	if (config->ospf != 0)
	{
		ospfNetworkPointer = config->ospf->ospfNetwork;
		while (ospfNetworkPointer != 0)
		{
			printf("OSPF Network: %s\n", ospfNetworkPointer->network);
			printf("  OSPF Network Mask: %s\n", ospfNetworkPointer->networkMask);
			printf("  OSPF Area ID: %s\n", ospfNetworkPointer->areaID);
			ospfNetworkPointer = ospfNetworkPointer->next;
		}
		ospfAreaPointer = config->ospf->ospfArea;
		while (ospfNetworkPointer != 0)
		{
			printf("OSPF Area ID: %s\n", ospfAreaPointer->areaID);
			printf("  OSPF Area Authentication: %d\n", ospfAreaPointer->areaAuth);
			printf("  OSPF Area Default Cost: %d\n", ospfAreaPointer->defaultCost);
			ospfAreaPointer = ospfAreaPointer->next;
		}
		ospfNeighborPointer = config->ospf->neighbor;
		while (ospfNeighborPointer != 0)
		{
			printf("OSPF Neighbor: %s\n", ospfNeighborPointer->host);
			printf("  OSPF Neighbor Priority: %d\n", ospfNeighborPointer->priority);
			printf("  OSPF Neighbor Poll Interval: %d\n", ospfNeighborPointer->pollInterval);
			printf("  OSPF Neighbor Cost: %d\n", ospfNeighborPointer->costNumber);
			printf("  OSPF Neighbor Database Filter: %d\n", ospfNeighborPointer->databaseFilter);
			ospfNeighborPointer = ospfNeighborPointer->next;
		}
	}

	// TACACS
	if (config->tacacs != 0)
	{
		printf("TACACS Key: %s\n", config->tacacs->key);
		printf("  TACACS Encrypted Key: %s\n", config->tacacs->keyEncrypted);
		printf("  TACACS Encryption Type: %d\n", config->tacacs->encryption);
		printf("  TACACS Weak Password: %d\n", config->tacacs->weak);
		printf("  TACACS Dictionary Password: %d\n", config->tacacs->dictionary);
		tacacsHostPointer = config->tacacs->host;
		while (tacacsHostPointer != 0)
		{
			printf("TACACS Server: %s\n", tacacsHostPointer->server);
			tacacsHostPointer = tacacsHostPointer->next;
		}
	}

	// AAA
	if (config->aaa != 0)
	{
		aaaGroupServerPointer = config->aaa->groupServer;
		while (aaaGroupServerPointer != 0)
		{
			printf("AAA Group Server Type: %d\n", aaaGroupServerPointer->type);
			printf("AAA Group Server Username: %s\n", aaaGroupServerPointer->username);
			aaaServerPointer = aaaGroupServerPointer->server;
			while (aaaServerPointer != 0)
			{
				printf("  AAA Server: %s\n", aaaServerPointer->server);
				printf("  AAA Auth Port: %d\n", aaaServerPointer->authPort);
				printf("  AAA Acct Port: %d\n", aaaServerPointer->acctPort);
				printf("  AAA Key: %s\n", aaaServerPointer->key);
				printf("  AAA Encrypted Key: %s\n", aaaServerPointer->keyEncrypted);
				printf("  AAA Encryption: %d\n", aaaServerPointer->encryption);
				printf("  AAA Weak Password: %d\n", aaaServerPointer->weak);
				printf("  AAA Dictionary Password: %d\n", aaaServerPointer->dictionary);
				aaaServerPointer = aaaServerPointer->next;
			}
			aaaGroupServerPointer = aaaGroupServerPointer->next;
		}
	}

	// Access-list
	accessPointer = config->access;
	while (accessPointer != 0)
	{
		printf("Access-List: %d\n", accessPointer->listNumber);
		printf("Description: %s\n", accessPointer->remark);
		permissionPointer = accessPointer->permission;
		while (permissionPointer != 0)
		{
			printf("  Permission: %d\n", permissionPointer->permission);
			printf("  Protocol: %s\n", permissionPointer->protocol);
			printf("  Source: %s\n", permissionPointer->source);
			printf("  Source Operator: %d\n", permissionPointer->sourceOperator);
			printf("  Source Service: %s\n", permissionPointer->sourceService);
			printf("  Source Service End: %s\n", permissionPointer->sourceServiceEnd);
			printf("  Destination: %s\n", permissionPointer->dest);
			printf("  Destination Operator: %d\n", permissionPointer->destOperator);
			printf("  Destination Service: %s\n", permissionPointer->destService);
			printf("  Destination Service End: %s\n", permissionPointer->destServiceEnd);
			printf("  Established: %d\n", permissionPointer->established);
			printf("  Fragments: %d\n", permissionPointer->fragments);
			printf("  Log: %d\n", permissionPointer->log);
			permissionPointer = permissionPointer->next;
		}
		accessPointer = accessPointer->next;
	}

	// NTP
	if (config->ntp != 0)
	{
		printf("NTP Enabled: %d\n", config->ntp->enabled);
		printf("  NTP Master: %d\n", config->ntp->master);
		ntpHostPointer = config->ntp->server;
		while (ntpHostPointer != 0)
		{
			printf("  NTP Server: %s\n", ntpHostPointer->ntpHost);
			printf("  NTP Server Key Num: %d\n", ntpHostPointer->keyNum);
			ntpHostPointer = ntpHostPointer->next;
		}
		ntpHostPointer = config->ntp->peer;
		while (ntpHostPointer != 0)
		{
			printf("  NTP Peer: %s\n", ntpHostPointer->ntpHost);
			printf("  NTP Peer Key Num: %d\n", ntpHostPointer->keyNum);
			ntpHostPointer = ntpHostPointer->next;
		}
		ntpAccessPointer = config->ntp->access;
		while (ntpAccessPointer != 0)
		{
			printf("  Access Type: %d\n", ntpAccessPointer->accessType);
			printf("  Access List Num: %d\n", ntpAccessPointer->accessList);
			ntpAccessPointer = ntpAccessPointer->next;
		}
		ntpKeyPointer = config->ntp->key;
		while (ntpKeyPointer != 0)
		{
			printf("NTP Key Num: %d\n", ntpKeyPointer->keyNum);
			printf("  NTP Key: %s\n", ntpKeyPointer->key);
			printf("  NTP Key Trusted: %d\n", ntpKeyPointer->trusted);
			printf("  NTP Weak Password: %d\n", ntpKeyPointer->weak);
			printf("  NTP Dictionary Password: %d\n", ntpKeyPointer->dictionary);
			ntpKeyPointer = ntpKeyPointer->next;
		}
	}

	// SNMP
	if (config->snmp != 0)
	{
		printf("SNMP Enabled: %d\n", config->snmp->enabled);
		printf("SNMP TFTP Server Access List: %d\n", config->snmp->tftpServerList);
		printf("SNMP Contact: %s\n", config->snmp->contact);
		printf("SNMP Location: %s\n", config->snmp->location);
		communityPointer = config->snmp->community;
		while (communityPointer != 0)
		{
			printf("SNMP Community String: %s\n", communityPointer->community);
			printf("  SNMP Weak Password: %d\n", communityPointer->weak);
			printf("  SNMP Dictionary Password: %d\n", communityPointer->dictionary);
			printf("  SNMP Read-Only: %d\n", communityPointer->readonly);
			printf("  SNMP Community Disabled: %d\n", communityPointer->disabled);
			printf("  SNMP Access List: %d\n", communityPointer->accessList);
			communityPointer = communityPointer->next;
		}
		snmpGroupPointer = config->snmp->group;
		while (snmpGroupPointer != 0)
		{
			printf("SNMP Group: %s\n", snmpGroupPointer->groupName);
			printf("  SNMP Group Security: %d\n", snmpGroupPointer->snmpSecurity);
			snmpUserPointer = snmpGroupPointer->user;
			while (snmpUserPointer != 0)
			{
				printf("  SNMP User: %s\n", snmpUserPointer->userName);
				printf("    SNMP User Auth Pass: %s\n", snmpUserPointer->authPass);
				printf("    SNMP User Priv Pass: %s\n", snmpUserPointer->privPass);
				snmpUserPointer = snmpUserPointer->next;
			}
			snmpGroupPointer = snmpGroupPointer->next;
		}
		snmpViewPointer = config->snmp->view;
		while (snmpViewPointer != 0)
		{
			printf("SNMP View: %s\n", snmpViewPointer->viewName);
			snmpViewItemPointer = snmpViewPointer->viewItem;
			while (snmpViewItemPointer != 0)
			{
				printf("  SNMP View MIB Item: %s\n", snmpViewItemPointer->mibId);
				printf("  SNMP View Item Include: %d\n", snmpViewItemPointer->include);
				snmpViewItemPointer = snmpViewItemPointer->next;
			}
			snmpViewPointer = snmpViewPointer->next;
		}
		snmpTrapPointer = config->snmp->trap;
		while (snmpTrapPointer != 0)
		{
			printf("SNMP Trap: %s\n", snmpTrapPointer->trap);
			snmpTrapPointer = snmpTrapPointer->next;
		}
		snmpHostPointer = config->snmp->host;
		while (snmpHostPointer != 0)
		{
			printf("SNMP Host: %s\n", snmpHostPointer->host);
			printf("  SNMP Host Community String: %s\n", snmpHostPointer->community);
			printf("  SNMP Weak Password: %d\n", snmpHostPointer->weak);
			printf("  SNMP Dictionary Password: %d\n", snmpHostPointer->dictionary);
			snmpHostPointer = snmpHostPointer->next;
		}
	}

	// Key Chains and Keys
	keyChainPointer = config->chain;
	while (keyChainPointer != 0)
	{
		printf("KEY CHAIN: %s\n", keyChainPointer->name);
		keyPointer = keyChainPointer->key;
		while (keyPointer != 0)
		{
			printf("  KEY NUMBER: %d\n", keyPointer->keyNumber);
			printf("  KEY: %s\n", keyPointer->key);
			printf("  KEY Weak Password: %d\n", keyPointer->weak);
			printf("  KEY Dictionary Password: %d\n", keyPointer->dictionary);
			keyPointer = keyPointer->next;
		}
		keyChainPointer = keyChainPointer->next;
	}

	// FTP
	if (config->ftp != 0)
	{
		printf("FTP Username: %s\n", config->ftp->username);
		printf("  FTP Password: %s\n", config->ftp->password);
		printf("  FTP Password Encrypted: %s\n", config->ftp->passwordEncrypted);
		printf("  FTP Encryption: %d\n", config->ftp->encryption);
		printf("  FTP Weak Password: %d\n", config->ftp->weak);
		printf("  FTP Dictionary Password: %d\n", config->ftp->dictionary);
		interfacePointer = config->ftp->interface;
		while (interfacePointer != 0)
		{
			printf("FTP Server Interface: %s\n", interfacePointer->interface);
			interfacePointer = interfacePointer->next;
		}
	}

	// Line
	linePointer = config->line;
	while (linePointer != 0)
	{
		printf("Line Start: %d\n", linePointer->lineNumberStart);
		printf("Line End: %d\n", linePointer->lineNumberEnd);
		printf("  Line Type: %d\n", linePointer->lineType);
		printf("  Line Login: %d\n", linePointer->lineLogin);
		printf("  Line Speed: %d\n", linePointer->lineSpeed);
		printf("  Line Timeout: %d\n", linePointer->timeout);
		printf("  Line Exec Timeout: %d\n", linePointer->execTimeout);
		printf("  Line Session Timeout: %d\n", linePointer->sessionTimeout);
		printf("  Line Absolute Timeout: %d\n", linePointer->absoluteTimeout);
		printf("  Line Exec: %d\n", linePointer->exec);
		printf("  Line Callback: %d\n", linePointer->callback);
		printf("  Line Password: %s\n", linePointer->password);
		printf("  Line Password Encrypted: %s\n", linePointer->passwordEncrypted);
		printf("  Line Password Encryption: %d\n", linePointer->encryption);
		printf("  Line Weak Password: %d\n", linePointer->weak);
		printf("  Line Dictionary Password: %d\n", linePointer->dictionary);
		linePointer = linePointer->next;
	}

	// Interfaces
	interfaceConfigPointer = config->interface;
	while (interfaceConfigPointer != 0)
	{
		printf("Interface: %s\n", interfaceConfigPointer->name);
		printf("  Description: %s\n", interfaceConfigPointer->description);
		printf("  IP Address: %s\n", interfaceConfigPointer->ipAddress);
		printf("  Access Group (In): %d\n", interfaceConfigPointer->accessGroupIn);
		printf("  Access Group (Out): %d\n", interfaceConfigPointer->accessGroupOut);
		printf("  Proxy ARP: %d\n", interfaceConfigPointer->proxyArp);
		printf("  NTP: %d\n", interfaceConfigPointer->ntp);
		printf("  MOP: %d\n", interfaceConfigPointer->mop);
		printf("  IP Unreachables: %d\n", interfaceConfigPointer->ipUnreachables);
		printf("  IP Redirects: %d\n", interfaceConfigPointer->ipRedirects);
		printf("  IP Mask Reply: %d\n", interfaceConfigPointer->ipMaskReply);
		printf("  IP Direct Broadcast: %d\n", interfaceConfigPointer->ipDirectBroadcast);
		printf("  CDP: %d\n", interfaceConfigPointer->cdp);
		printf("  Shutdown: %d\n", interfaceConfigPointer->shutdown);
		printf("  RIP Auth Mode: %d\n", interfaceConfigPointer->ripAuthMode);
		printf("  RIP Key Chain: %s\n", interfaceConfigPointer->ripKeyChain);
		printf("  OSPF Auth: %d\n", interfaceConfigPointer->ospfAuthentication);
		printf("  OSPF Auth Key: %s\n", interfaceConfigPointer->ospfKey);
		printf("  OSPF Flood Reduction: %d\n", interfaceConfigPointer->ospfFloodReduction);
		printf("  OSPF Network: %d\n", interfaceConfigPointer->ospfNetwork);
		interfaceConfigPointer = interfaceConfigPointer->next;
	}

	// John-the-ripper
	if (config->john != 0)
	{
		printf("\n%sJohn-the-ripper Output\n======================%s\n", COL_BLUE, RESET);
		johnPointer = config->john;
		while (johnPointer != 0)
		{
			printf("Username: %s\n", johnPointer->username);
			printf("  Password: %s\n", johnPointer->password);
			johnPointer = johnPointer->next;
		}
	}
}


