/***************************************************************************
 *   Copyright (C) 2006 - 2007 by Ian Ventura-Whiting (Fizz)               *
 *   Fizz@Titania.co.uk                                                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


// Process EnablePass / Password
void processEnablePass(char *line, struct ciscoNMPConfig *configNMP, const int debugMode)
{
	// Enable Password?
	if (strncmp("set enablepass ", line, 15) == 0)
	{
		// Debug output
		if (debugMode == true)
			printf("Enable Password Line: %s\n", line);

		strncpy(configNMP->enablePassword, line + 15, sizeof(configNMP->enablePassword) - 1);
		addNMPJohnPassword(configNMP, "Enable", configNMP->enablePassword);
	}

	// Password
	else if (strncmp("set password ", line, 13) == 0)
	{
		// Debug output
		if (debugMode == true)
			printf("Login Password Line: %s\n", line);

		strncpy(configNMP->password, line + 13, sizeof(configNMP->password) - 1);
		addNMPJohnPassword(configNMP, "LoginPassword", configNMP->password);
	}
}


struct switchNMPConfig
{
	int ipRedirect;					// true or false
	int ipUnreachable;				// true or false
	int ipFragmentation;			// true or false
};


// ICMP IP Unreachable
void processNMPUnreachable(char *line, struct ciscoNMPConfig *configNMP, const int debugMode)
{
	// Variables
	struct ciscoCommand command;

	// Debug output
	if (debugMode == true)
		printf("ICMP IP Unrachable Line: %s\n", line);

	// Is switch configuration is not set
	if (configNMP->switchConfig == 0)
	{
		configNMP->switchConfig = malloc(sizeof(struct switchNMPConfig));
		memset(configNMP->switchConfig, 0 , sizeof(struct switchNMPConfig));
		configNMP->switchConfig->ipRedirect = true;
		configNMP->switchConfig->ipUnreachable = true;
		configNMP->switchConfig->ipFragmentation = true;
	}

	// Init
	command = splitLine(line);

	if (strcmp(command.part[3], "enable") == 0)
		configNMP->switchConfig->ipUnreachable = true;
	else
		configNMP->switchConfig->ipUnreachable = false;
}


// IP Redirects
void processNMPRedirect(char *line, struct ciscoNMPConfig *configNMP, const int debugMode)
{
	// Variables
	struct ciscoCommand command;

	// Debug output
	if (debugMode == true)
		printf("IP Redirect Line: %s\n", line);

	// Is switch configuration is not set
	if (configNMP->switchConfig == 0)
	{
		configNMP->switchConfig = malloc(sizeof(struct switchNMPConfig));
		memset(configNMP->switchConfig, 0 , sizeof(struct switchNMPConfig));
		configNMP->switchConfig->ipRedirect = true;
		configNMP->switchConfig->ipUnreachable = true;
		configNMP->switchConfig->ipFragmentation = true;
	}

	// Init
	command = splitLine(line);

	if (strcmp(command.part[3], "enable") == 0)
		configNMP->switchConfig->ipRedirect = true;
	else
		configNMP->switchConfig->ipRedirect = false;
}


// Fragmentation
void processNMPFragmentation(char *line, struct ciscoNMPConfig *configNMP, const int debugMode)
{
	// Variables
	struct ciscoCommand command;

	// Debug output
	if (debugMode == true)
		printf("IP Fragmentation Line: %s\n", line);

	// Is switch configuration is not set
	if (configNMP->switchConfig == 0)
	{
		configNMP->switchConfig = malloc(sizeof(struct switchNMPConfig));
		memset(configNMP->switchConfig, 0 , sizeof(struct switchNMPConfig));
		configNMP->switchConfig->ipRedirect = true;
		configNMP->switchConfig->ipUnreachable = true;
		configNMP->switchConfig->ipFragmentation = true;
	}

	// Init
	command = splitLine(line);

	if (strcmp(command.part[3], "enable") == 0)
		configNMP->switchConfig->ipFragmentation = true;
	else
		configNMP->switchConfig->ipFragmentation = false;
}


