/***************************************************************************
 *   Copyright (C) 2006 - 2007 by Ian Ventura-Whiting (Fizz)               *
 *   Fizz@Titania.co.uk                                                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


// Enable password(s)
struct enablePIXPassword
{
	char passwordEncrypted[64];
	int level;
	struct enablePIXPassword *next;
};


struct usernamePIX
{
	char username[16];
	char passwordEncrypted[64];
	int encryption;
	int level;
	struct usernamePIX *next;
};


// Process enable
void processEnablePIX(char *line, struct ciscoPIXConfig *configPIX, const int debugMode)
{
	// Variables...
	struct ciscoCommand command;
	struct enablePIXPassword *enablePIXPointer;
	int tempInt;

	// Debug
	if (debugMode == true)
	{
		printf("Enable Line: %s\n", line);
	}

	// Init
	command = splitLine(line);

	// Is it an enable password?
	if (strncmp(line, "enable password ", 16) == 0)
	{
		// Is this the first enable password?
		if (configPIX->enable == 0)
		{
			configPIX->enable = malloc(sizeof(struct enablePIXPassword));
			enablePIXPointer = configPIX->enable;
		}
		else
		{
			enablePIXPointer = configPIX->enable;
			while (enablePIXPointer->next != 0)
				enablePIXPointer = enablePIXPointer->next;
			enablePIXPointer->next = malloc(sizeof(struct enablePIXPassword));
			enablePIXPointer = enablePIXPointer->next;
		}

		// Init
		memset(enablePIXPointer, 0, sizeof(struct enablePIXPassword));
		enablePIXPointer->level = 15;

		// Password
		strncpy(enablePIXPointer->passwordEncrypted, command.part[2], sizeof(enablePIXPointer->passwordEncrypted) - 1);
		addPIXJohnPassword(configPIX, "Enable", enablePIXPointer->passwordEncrypted);

		// Get options
		tempInt = 3;
		if (tempInt < command.parts)
		{
			// Level
			if (strcmp(command.part[tempInt], "level") == 0)
			{
				tempInt++;
				enablePIXPointer->level = atoi(command.part[tempInt]);
			}

			tempInt++;
		}
	}

	// If it is a passwd
	else if (strncmp("passwd ", line, 7) == 0)
	{
		strncpy(configPIX->password, command.part[1], sizeof(configPIX->password) - 1);
		addPIXJohnPassword(configPIX, "LoginPassword", configPIX->password);
	}
}


// Process Username
void processPIXUsername(char *line, struct ciscoPIXConfig *configPIX, const int debugMode)
{
	// Variables...
	struct ciscoCommand command;
	struct usernamePIX *usernamePIXPointer;
	int tempInt;

	// Debug
	if (debugMode == true)
	{
		printf("Username Line: %s\n", line);
	}

	// Is it the first?
	if (configPIX->username == 0)
	{
		configPIX->username = malloc(sizeof(struct usernamePIX));
		usernamePIXPointer = configPIX->username;
	}
	else
	{
		usernamePIXPointer = configPIX->username;
		while (usernamePIXPointer->next != 0)
			usernamePIXPointer = usernamePIXPointer->next;
		usernamePIXPointer->next = malloc(sizeof(struct usernamePIX));
		usernamePIXPointer = usernamePIXPointer->next;
	}

	// Init
	memset(usernamePIXPointer, 0, sizeof(struct usernamePIX));
	command = splitLine(line);
	usernamePIXPointer->level = 2;

	// Username
	strncpy(usernamePIXPointer->username, command.part[1], sizeof(usernamePIXPointer->username) - 1);

	// Other options...
	tempInt = 2;
	while (tempInt < command.parts)
	{
		// No password
		if (strcmp(command.part[tempInt], "nopassword") == 0)
			usernamePIXPointer->encryption = encrypt_none;
		
		// Password
		else if (strcmp(command.part[tempInt], "password") == 0)
		{
			strncpy(usernamePIXPointer->passwordEncrypted, command.part[tempInt +1], sizeof(usernamePIXPointer->passwordEncrypted) - 1);
			tempInt++;
		}

		// Encrypted
		else if (strcmp(command.part[tempInt], "encrypted") == 0)
			usernamePIXPointer->encryption = encrypt_pix;

		// MSChap
		else if (strcmp(command.part[tempInt], "mschap") == 0)
			usernamePIXPointer->encryption = encrypt_mschap;

		// NT Encrypted
		else if (strcmp(command.part[tempInt], "nt-encrypted") == 0)
			usernamePIXPointer->encryption = encrypt_ntenc;

		// Level
		else if (strcmp(command.part[tempInt], "privilege") == 0)
			usernamePIXPointer->level = atoi(command.part[tempInt +1]);

		tempInt++;
	}

	// If password is encrypted
	if (usernamePIXPointer->encryption == encrypt_pix)
		addPIXJohnPassword(configPIX, usernamePIXPointer->username, usernamePIXPointer->passwordEncrypted);
}

