/***************************************************************************
 *   Copyright (C) 2006 - 2007 by Ian Ventura-Whiting (Fizz)               *
 *   Fizz@Titania.co.uk                                                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


// Process SSH Service Lines
void processSOSSSH(char *line, struct screenOSConfig *configSOS, int maxSize, const int debugMode)
{
	// Variables
	struct ciscoCommand command;

	// Debug Output
	if (debugMode == true)
		printf("SSH Line: %s\n", line);

	// Init
	command = splitLine(line);

	// Version?
	if (strcmp(command.part[2], "version") == 0)
	{
		if (strcmp(command.part[3], "v1") == 0)
			configSOS->sshVersion = 1;
		else if (strcmp(command.part[3], "v2") == 0)
			configSOS->sshVersion = 2;
	}

	// Enabled?
	else if (strcmp(command.part[2], "enable") == 0)
		configSOS->sshEnabled = true;

	// SSH v1 Key Gen Time
	else if (strcmp(command.part[2], "key-gen-time") == 0)
		configSOS->sshKeyGenTime = atoi(command.part[3]);

	// SSH v2 Public Key
	else if (strcmp(command.part[2], "pub-key") == 0)
		strncpy(configSOS->sshPublicKey, command.part[3], sizeof(configSOS->sshPublicKey) - 1);
}

